<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import _ from "lodash";
import { apiErrorHandler } from "~/utils/apiHanlers";
import { userInfoKey } from "~/common/constaint";
var momentz = require("moment-timezone");
var moment = require("moment");
@Component({})
export default class AdminOrderComponent extends Vue {
  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  totalPage: number = 0;
  page = 1;

  loading = false;
  loadingTable = false;
  selectedAll = false;
  listUser = [];
  userInfo: any = {};

  async mounted() {
    this.userInfo = await this.$localForage.getItem(userInfoKey);
    this.onGetListCustomer();
  }

  async onGetListCustomer() {
    try {
      let response;
      this.loadingTable = true;
      if (this.userInfo && this.userInfo.role === 1) {
        response = await this.$api.user.getAllAdmin(this.config);
      } else if (this.userInfo && this.userInfo.role === 2) {
        response = await this.$api.user.masterGetAllUser(this.config);
      }
      const { total } = response.data;
      this.totalPage = Math.ceil(total / this.config.limit);
      if (response?.data?.data) {
        this.listUser = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTable = false;
    }
  }

  async onActiveUser(user: any) {
    try {
      const isActive = user.isActive ? true : false;
      await this.$api.user.masterActiveUser(user._id, isActive);
      this.$pushNotification.success("User status update successful");
      this.onGetListCustomer();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  onRedirectPage() {
    this.config.page = this.page;
    this.onGetListCustomer();
  }

  formatDate(date: string) {
    return moment(date).format("HH:mm DD/MM/YYYY");
  }

  @Watch("config.page")
  changePage() {
    this.onGetListCustomer();
  }

  @Watch("config.search")
  changeSearch(val: string) {
    if (!val) {
      this.onGetListCustomer();
    }
  }
}
</script>

<style></style>
